*************
*  Arquivo de Cabecalho
*
*  ANTHURION Informatica
*    CLIPPER's Club
*/


// Estas linhas sao responsaveis pela substituicao do comando PROMPT
// do Clipper, pelas nossas funcoes.
//
// O comando PROMPT e substituido pela matriz aPrompt e o comando SETPOS().
//
// O comando MENU TO e substituido pela funcao _MenuTo2()

#command @ <row>, <col> PROMPT <prompt>                                     ;
                        [MESSAGE <msg>]                                     ;
                        [NIVEL <niv> ]                                      ;
                        [WHEN <cond> ]                                      ;
                        [FUNC <func> ]                                      ;
                        [<botao:BOTAO> ]                                    ;
                        [TAM <tam> ]                                        ;
                        [<chr:CHR> ]                                        ;
      => _MenuTo2(, <row>, <col>,  <prompt>                                 ,;
                                  <msg>                                    ,;
                                [ <niv>  ]                                 ,;
                                [ <.botao.> ]                              ,;
                                [ <tam> ]                                 ,,;
                                [ <.chr.> ]                                ,;
                                [ <cond> ]                                ,,;
                                [ <func> ]  )                              ;;
         SETPOS(<row>,<col>+LEN(<prompt>)-1)


// Nao esquecer de definir a variavel <v>.
#command MENU TO <Pos> [<botao:BOTAO>] [TAM <tam>] [<ajusta:AJUSTA>] [<chr:CHR>] [LINHAS <linhas>] [<cor:COLOR>] [<ver:VERTICAL>] [<hor:HORIZONTAL>];
      => <Pos> := _MenuTo2( {|_1| if(PCount() == 0, <Pos>, <Pos> := _1)} ,,,,,,[<.botao.>],[<tam>],[<.ajusta.>],[<.chr.>],,[<linhas>],,[<.cor.>],[<.ver.>] [!<.hor.>] )

#translate BOTAO()              ;
      =>   _MenuTo2(,,,,,,.T.,,,)

#translate BOTAO( <Pos> )              ;
      =>   _MenuTo2( {|_1| if(PCount() == 0, <Pos>, <Pos> := _1)} ,,,,,,.T.,,,)

#translate BOTAO( <Lin>, <Col>, <Texto> )              ;
       => SETPOS( <Lin>, <Col> )                      ;;
            _Say( <Texto>,,,.T.,,10)

#translate BOTAO( <Lin>, <Col>, <Texto> ,[<a>] [,<Tam>] )              ;
      =>   _MenuTo2(,<Lin> ,<Col> ,<Texto> ,,,,[<Tam>],, )


#translate ACHOICE( <Lin>, <Col>, <Lin_F>, <Col_F>, <Matriz> )             ;
      =>  ACHOICE( <Lin>, <Col>, <Lin_F>, <Col_F>, <Matriz>,,, )

#translate ACHOICE( <Lin>,<Col>,<Lin_F>,<Col_F>,<Matriz>,[<Cond>] )    ;
      =>  ACHOICE( <Lin>,<Col>,<Lin_F>,<Col_F>,<Matriz>,[<Cond>],, )

#translate ACHOICE( <Lin>,<Col>,<Lin_F>,<Col_F>,<Matriz>,[<Cond>], [<UDF>] )  ;
      =>  ACHOICE( <Lin>,<Col>,<Lin_F>,<Col_F>,<Matriz>,[<Cond>], [<UDF>], )


#translate ACHOICE( <Lin>                                             ,;
                    <Col>                                             ,;
                    <Lin_F>                                           ,;
                    <Col_F>                                           ,;
                    <Matriz>                                          ,;
                    [<Cond>]                                          ,;
                    [<UDF> ]                                          ,;
                    [<Pos> ]                                          );
      =>   _MenuTo2([{|_1| if(PCount() == 0, <Pos>, <Pos> := _1)}]     ,;
                    <Lin>                                             ,;
                    <Col>                                             ,;
                    <Matriz>                                          ,;
                    "ACHOICE"                                         ,;
                                                                      ,;
                                                                      ,;
                    <Col_F>-<Col>-1                                   ,;
                                                                      ,;
                                                                      ,;
                   [<Cond>]                                           ,;
                   <Lin_F>+1-<Lin>                                    ,;
                   [<UDF>]                                             )



#IFDEF xHarbour

#else

 /***
 *  @..GET
 */

 #xtranslate   .GET_POS    =>    \[LEN(GetList),1]



 #command @ <row> , <col>  GET <var> ;
            [<clauses,...>]         ;
            PASSWORD                ;
            [<moreClauses,...>]     ;
                                    ;
      => @ <row> , <col>  GET <var> ;
            [<clauses>]             ;
            SEND reader := {|oGet|  ;
                 GetPassword(oGet) };
                 [<moreClauses>]



 #command @ <row>, <col> GET <var>                                       ;
                        [PICTURE <pic>]                                 ;
                        [VALID <valid>]                                 ;
                        [WHEN <when>]                                   ;
                        [MSG <msg>]                                     ;
                        [SEND <send>]                                   ;
                                                                        ;
      => SetPos( <row>, <col> )                                         ;
       ; AAdd(                                                          ;
           GetList,{                                                    ;
           _GET_( <var>, <"var">, <pic>, <{valid}>, <{when}> ):display();
             ,[<msg>]} )                                                ;
          [; GetList.GET_POS:<send>]

#endif
#STDOUT "SE - Softwares Edmar e S.E. Sistemas Ltda DOS/WINDOWS"

//#define HB_EXT_SHIFT_KEYS_CODES