// AS MEDIDAS USADAS FORAM BASEADAS NA FONTE: HFont():Add( 'Courier New',0,-12 )

// altura da linha do SAY
//#define pALTSAY 16
#define pALTSAY 18

// altura da linha do GET
#define pALTGET 20

// tamanho de uma linha
#define pTAMLINHA 20

// tamanho de uma coluna
#define pTAMCHAR 7

// tamanho em colunas (SIZE) do get
#translate tamget( <x> )     => ( 15 + ( pTAMCHAR * ( <x> -1 ) ) )

// tamanho em colunas (SIZE) do say
#translate tamsay( <x> )     => (  8 + ( pTAMCHAR * ( <x> -1 ) ) )

// tamanho em linhas (SIZE) do get
#translate linGet( <x> )     => (  2 + ( pTAMLINHA * ( <x> ) ) )

// tamanho em linhas (SIZE) do say
#translate linSay( <x> )     => (  5 + ( pTAMLINHA * ( <x> ) ) )

// tamanho em colunas
#translate colWin( <x> )     => (  2 + ( pTAMCHAR  * ( <x> ) ) )

#DEFINE pCORAZUL Vcolor("8F0000")
//#DEFINE pCORAZUL Vcolor("000000")
#DEFINE pCORSAY  16711680

// COMANDO XSAY COM FORMATO linha,coluna com SIZE automtico
#xcommand @ <x>,<y> XSAY [ <oSay> CAPTION ] <caption> ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;
           =>;
          @ colWin(<y>),linSay(<x>) SAY [ <oSay> CAPTION ] <caption>;
            SIZE tamSay(LEN(<caption>)), pALTSAY ;
            COLOR mCorFrente           ; 
            BACKCOLOR mCorFundo        ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;

// COMANDO XSAY COM FORMATO linha,coluna com SIZE informado
#xcommand @ <x>,<y> XSAY [ <oSay> CAPTION ] <caption> SIZE <xlin>,<xcol>;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;
           =>;
          @ colWin(<y>),linSay(<x>) SAY [ <oSay> CAPTION ] <caption>;
            SIZE tamSay(<xcol>), pALTSAY*<xlin> ;
            COLOR mCorFrente           ; 
            BACKCOLOR mCorFundo        ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;

// COMANDO XSAY COM FORMATO linha,coluna com SIZE automatico e deslocamento de 3 pixels
// para ficar mais perto do GET.
#xcommand @ <x>,<y> XSAY [ <oSay> CAPTION ] <caption> TITULO;
            [ OF <oWnd> ]              ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;
           =>;
          @ colWin(<y>),linSay(<x>) SAY [ <oSay> CAPTION ] <caption>;
            SIZE tamSay(LEN(<caption>)), pALTSAY ;
            [ OF <oWnd> ]              ;
            COLOR mCorFrente           ; 
            BACKCOLOR mCorFundo        ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;


// COMANDO XSAY COM FORMATO linha,coluna e com BORDA e tamanho automatico
#xcommand @ <x>,<y> XSAY [ <oSay> CAPTION ] <caption> BORDER;
            [ OF <oWnd> ]              ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;
           =>;
          @ colWin(<y>),linSay(<x>) SAY [ <oSay> CAPTION ] <caption> SIZE tamSay(LEN(<caption>)), pALTSAY ;
            [ OF <oWnd> ]              ;
            COLOR mCorFrente           ; 
            BACKCOLOR mCorFundo        ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;;
          @ colWin(<y>)-3,linSay(<x>)-3 SAY "" STYLE SS_ETCHEDFRAME SIZE tamSay(LEN(<caption>)+1),pALTSAY+5

// COMANDO XSAY COM FORMATO linha,coluna e com BORDA e tamanho informado
#xcommand @ <x>,<y> XSAY [ <oSay> CAPTION ] <caption> BORDER SIZE <xlin>,<xcol>;
            [ OF <oWnd> ]              ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;
           =>;
          @ colWin(<y>),linSay(<x>) SAY [ <oSay> CAPTION ] <caption> ;
            SIZE tamSay(<xcol>), <xlin>*pALTSAY ;
            [ OF <oWnd> ]              ;
            COLOR mCorFrente           ; 
            BACKCOLOR mCorFundo        ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;;
          @ colWin(<y>)-3,linSay(<x>)-3 SAY "" STYLE SS_ETCHEDFRAME SIZE tamSay(<xcol>+1),(<xlin>)*pALTSAY+5


// BORDER SIZE E COR
#xcommand @ <x>,<y> XSAY2 [ <oSay> CAPTION ] <caption> BORDER SIZE <xlin>,<xcol>;
            [ OF <oWnd> ]              ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;
           =>;
          @ colWin(<y>),linSay(<x>) SAY [ <oSay> CAPTION ] <caption> ;
            SIZE tamSay(<xcol>), <xlin>*pALTSAY ;
            [ OF <oWnd> ]              ;
            [ COLOR <color> ]          ; 
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;;
          @ colWin(<y>)-3,linSay(<x>)-3 SAY "" STYLE SS_ETCHEDFRAME SIZE tamSay(<xcol>+1),(<xlin>)*pALTSAY+5


// COMANDO GET COM FORMATO linha,coluna
#xcommand @ <x>,<y> XGET <xvar> ;
            [ OF <oWnd> ]              ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ID      <cID> ]     ;
            [ PICT    <cPicture> ]     ;
            [ WHEN  <bGfocus> ]        ;
            [ VALID <bLfocus> ]        ;
            [ ON INIT <bInit> ]        ;
            [ STYLE <nStyle> ]         ;
            [ TOOLTIP <ctoolt> ]       ;         
            [ MAXLENGTH <nMaxLength> ] ;
            SIZE <xlin>,<xcol> =>;
          @ colWin(<y>),linGet(<x>) GET e<xvar> VAR <xvar> ;
            SIZE tamGet(<xcol>), pALTGET+(<xlin>-1)*pALTSAY ;
            FONT oFonteG ;
            [ OF <oWnd> ]              ;
            [ PICTURE <cPicture> ]     ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ WHEN  <bGfocus> ]        ;
            [ ID    <cID>     ]        ;
            [ ON INIT <bInit> ]        ;
            [ VALID <bLfocus> ]        ;
            [ STYLE <nStyle> ]         ;
            [ TOOLTIP <ctoolt> ]       ;
            [ MAXLENGTH <nMaxLength> ] 


////////by Edmar

// COMANDO GET COM FORMATO linha,coluna COM TAMITEM E UM SAY COM BORDA
#xcommand @ <x>,<y> EGET <xvar>  TAMITEM <eTamanho> ;
            [ OF <oWnd> ]              ;
            [ COLOR <color> ]          ;
            [ ITEMS <eitems> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ID      <cID> ]     ;
            [ PICT    <cPicture> ]     ;
            [ WHEN  <bGfocus> ]        ;
            [ MAXLENGTH <nMaxLength> ] ;
            [ ON INIT <bInit> ]        ;
            [ VALID <bLfocus> ]        ;
            [ STYLE <nStyle> ]         ;
            [ TOOLTIP <ctoolt> ]       ;
            SIZE <xlin>,<xcol> =>;
          @ colWin(<y>),linGet(<x>) GET e<xvar> VAR <xvar> ;
            SIZE tamGet(<xcol>), pALTGET+(<xlin>-1)*pALTSAY ;
            FONT oFonteG ;
            [ OF <oWnd> ]              ;
            [ PICTURE <cPicture> ]     ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ WHEN  <bGfocus> ]        ;
            [ ID    <cID>     ]        ;
            [ ON INIT <bInit> ]        ;
            [ MAXLENGTH <nMaxLength> ] ;
            [ VALID <bLfocus> ]        ;
            [ STYLE <nStyle> ]         ;
            [ TOOLTIP <ctoolt> ]       ;;
          @ <x>,<y>+(2+<xcol>) XSAY o<xvar> CAPTION SPACE(<eTamanho>);
            BORDER SIZE 1,<eTamanho>

#xcommand @ <x>,<y> EGET <xvar>  BOTAO <eOnClickFuncao> TAMITEM <eTamanho> ;
            [ OF <oWnd> ]              ;
            [ COLOR <color> ]          ;
            [ ITEMS <eitems> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ID      <cID> ]     ;
            [ PICT    <cPicture> ]     ;
            [ MAXLENGTH <nMaxLength> ] ;
            [ WHEN  <bGfocus> ]        ;
            [ VALID <bLfocus> ]        ;
            [ STYLE <nStyle> ]         ;
            [ TOOLTIP <ctoolt> ]       ;
            SIZE <xlin>,<xcol> =>;
          @ colWin(<y>),linGet(<x>) GET e<xvar> VAR <xvar> ;
            SIZE tamGet(<xcol>), pALTGET+(<xlin>-1)*pALTSAY ;
            FONT oFonteG ;
            [ OF <oWnd> ]              ;
            [ PICTURE <cPicture> ]     ;
            [ MAXLENGTH <nMaxLength> ] ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ WHEN  <bGfocus> ]        ;
            [ ID    <cID>     ]        ;
            [ VALID <bLfocus> ]        ;
            [ STYLE <nStyle> ]         ;
            [ TOOLTIP <ctoolt> ]       ;;
          @ <x>,<y>+(5+<xcol>) XSAY o<xvar> CAPTION SPACE(<eTamanho>);
            BORDER SIZE 1,<eTamanho> ;;
          @ colWin(<y>+<xcol>+2),LinGet(<x>) BUTTON btn<xvar> CAPTION "..." SIZE tamSay(2),pALTGET ;
             ON CLICK <eOnClickFuncao> 
            
#xcommand @ <x>,<y> eSAY [ <oSay> CAPTION ] <caption> SIZE <xlin>,<xcol>;
            [ OF <oWnd> ]              ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;
           =>;
          @ colWin(<y>),linSay(<x>) SAY [ <oSay> CAPTION ] <caption> ;
            SIZE tamSay(<xcol>), <xlin>*pALTSAY ;
            COLOR mCorFrente           ; 
            BACKCOLOR mCorFundo        ;
            FONT oFONTEG               ;
            [ OF <oWnd> ]              ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ TOOLTIP <ctoolt> ]       ;;
          @ colWin(<y>)-3,linSay(<x>)-3 SAY "" STYLE SS_ETCHEDFRAME SIZE tamSay(<xcol>+1),(<xlin>)*pALTSAY+5

#xcommand @ <x>,<y> eSAY2 [ <oSay> CAPTION ] <caption> SIZE <xlin>,<xcol>;
            [ OF <oWnd> ]              ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;
           =>;
          @ colWin(<y>),linSay(<x>) SAY [ <oSay> CAPTION ] <caption> ;
            SIZE tamSay(<xcol>), <xlin>*pALTSAY ;
            FONT oFONTEG               ;
            [ COLOR <color> ]          ;
            [ BACKCOLOR <bcolor> ]     ;
            [ OF <oWnd> ]              ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ TOOLTIP <ctoolt> ]       ;;
          @ colWin(<y>)-3,linSay(<x>)-3 SAY "" STYLE SS_ETCHEDFRAME SIZE tamSay(<xcol>+1),(<xlin>)*pALTSAY+5

//alterado				
#xcommand @ <x>,<y> GROUPBOX [ <oGroup> CAPTION ] <caption> ;
             [ OF <oWnd> ]              ;
             [ ID <nId> ]               ;
             [ SIZE <width>, <height> ] ;
             [ COLOR <color> ]          ;
             [ BACKCOLOR <bcolor> ]     ;
             [<lTransp: TRANSPARENT>]   ;
             [ FONT <oFont> ]           ;
             [ ON INIT <bInit> ]        ;
             [ ON SIZE <bSize> ]        ;
             [ ON PAINT <bDraw> ]       ;
             [ STYLE <nStyle> ]         ;
          => ;
          [<oGroup> := ] HGroup():New( <oWnd>,<nId>,<nStyle>,<x>,<y>,<width>, ;
             <height>,<caption>,oFonte,<bInit>,<bSize>,<bDraw>,mCorFrente,mCorFundo,<.lTransp.>);;
          [ <oGroup>:name := <(oGroup)> ]

#xcommand @ <x>,<y> eSAYCOR [ <oSay> CAPTION ] <caption> SIZE <xlin>,<xcol>;
            [ OF <oWnd> ]              ;
            [ COLOR <color> ]     ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ FONT <oFont> ]           ;
            [ TOOLTIP <ctoolt> ]       ;
           =>;
          @ colWin(<y>),linSay(<x>) SAY [ <oSay> CAPTION ] <caption> ;
            SIZE tamSay(<xcol>), <xlin>*pALTSAY ;
            FONT oFONTEG               ;
            [ OF <oWnd> ]              ;
            [ COLOR     <color> ]     ;
            [ BACKCOLOR <bcolor> ]     ;
            [ ON INIT <bInit> ]        ;
            [ ON PAINT <bDraw> ]       ;
            [ STYLE <nStyle> ]         ;
            [ TOOLTIP <ctoolt> ]       ;;
          @ colWin(<y>)-3,linSay(<x>)-3 SAY "" STYLE SS_ETCHEDFRAME SIZE tamSay(<xcol>+1),(<xlin>)*pALTSAY+5
